//+------------------------------------------------------------------+ 
//|                                       MasterMartingale v1.03.mq4 |
//|                                               copyright 2006 DGC |
//+------------------------------------------------------------------+

//v1.00: Original version
//v1.01: Added Target and BailOut lines
//v1.02: Fixed multiple trade bug; integrated DisplayInfo routine
//v1.03: Corrected spread calculation error

#property copyright "Copyright  2006 DGC"

extern int     TP          = 10;
extern int     SL          = 10;
extern int     Direction   = 1;
extern double  Lots        = 0.01;
extern int     mm          = 0;
extern int     TradeMode   = 1;// 1 = counter, 2 = alternator, 3 = indicator
extern int     MagicNumber = 962245;

//int ticket;
int            LONG        = 1;
int            SHORT       = -1;
double         dTarget     = 0;
double         dBailOut    = 0;
int            iTradeDir   = 0;
int            iLosses     = 0;
int            cnt         = 0;
int            slippage    = 3;
int            ticket      = 0;
double         lotsi       = 0;
double         mylotsi     = 0;
bool           bInTrade    = FALSE;
string         CurrentBuild= "v1.03";

int init(){return(0);}
int deinit(){return(0);}

int start()
{
   int cnt = 0;

//1. Money management & trade sizing
   if (mm != 0)
      lotsi = MathRound(AccountBalance() * 0.0002) / 100;
   else
      lotsi = Lots;
   mylotsi = NormalizeDouble(lotsi * MathPow(2, iLosses), 2);
   if (mylotsi > 100) mylotsi = 100;

   if (bInTrade == FALSE)
   {
      switch(TradeMode)
      {
         case 1:  // Counter-trading mode
            iTradeDir = Direction;
            break;
            
         case 2:  // Alternating trading mode
            if (iTradeDir == 0)
               iTradeDir = Direction;
            else
               iTradeDir = -iTradeDir;            
            break;
            
         case 3:  // Indicator trading mode
            if(iCustom(NULL, 15, "i_Trend_s", 0, 0, 0, 30, 2, 20, 300, 0, 0) > 0)
               iTradeDir = LONG;
            else
               iTradeDir = SHORT;   
            break;
      }
      if (iTradeDir == LONG)
      {
         dTarget = Ask + TP * Point;
         dBailOut = Ask - SL * Point;
         ticket = OrderSend(Symbol(), OP_BUY, mylotsi, Ask, slippage, 0, 0, NULL, MagicNumber, 0, White);
         bInTrade = TRUE;
         Alert("Open #",ticket,"  InTrade = ",bInTrade);
         ObjectCreate("Target", OBJ_HLINE, 0, 0, dTarget);
         ObjectCreate("BailOut", OBJ_HLINE, 0, 0, dBailOut);
      }
      else
      {
         dTarget = Bid - TP * Point;
         dBailOut = Bid + TP * Point;
         ticket = OrderSend(Symbol(), OP_SELL, mylotsi, Bid, slippage, 0, 0, NULL, MagicNumber, 0, Red);
         bInTrade = TRUE;
         Alert("Open #",ticket,"  InTrade = ",bInTrade);
         ObjectCreate("Target", OBJ_HLINE, 0, 0, dTarget);
         ObjectCreate("BailOut", OBJ_HLINE, 0, 0, dBailOut);
      }
   }
   else

   {
      for(cnt = 0; cnt < OrdersTotal(); cnt ++)   
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         ticket = OrderTicket();
      }
   }   
   
   if (iTradeDir == LONG)
   {
      if (Bid <= dBailOut)
      {
         OrderClose(ticket, OrderLots(), OrderClosePrice(), slippage, White);
         bInTrade = FALSE;
         Alert("Close #",ticket,"  InTrade = ",bInTrade);         
         ObjectDelete("Target");
         ObjectDelete("BailOut");
         iLosses ++;
      }
      if (Bid >= dTarget)
      {
         OrderClose(ticket, OrderLots(), OrderClosePrice(), slippage, White);
         bInTrade = FALSE;
         Alert("Close #",ticket,"  InTrade = ",bInTrade);         
         ObjectDelete("Target");
         ObjectDelete("BailOut");
         iLosses = 0;
         iTradeDir = 0;
      }   
   }
   
   if (iTradeDir == SHORT)
   {
      if (Ask >= dBailOut)
      {
         OrderClose(ticket, OrderLots(), OrderClosePrice(), slippage, Red);
         bInTrade = FALSE;
         Alert("Close #",ticket,"  InTrade = ",bInTrade);         
         ObjectDelete("Target");
         ObjectDelete("BailOut");
         iLosses ++;
      }
      if (Ask <= dTarget)
      {
         OrderClose(ticket, OrderLots(), OrderClosePrice(), slippage, Red);
         bInTrade = FALSE;
         Alert("Close #",ticket,"  InTrade = ",bInTrade);         
         ObjectDelete("Target");
         ObjectDelete("BailOut");
         iLosses = 0;
         iTradeDir = 0;
      }      
   }
   Comment("Trade Mode = ", TradeMode,
           "  Direction = ", iTradeDir,
           "\nLots = ", mylotsi,
           "  Losses = ", iLosses,
           "\nBuild: ", CurrentBuild);
   
   return(0);
}


